Public Delegate Function MyFxDelegate(ByVal nNumVars As Integer, ByRef fX() As Double, ByRef fParam() As Double) As Double
Public Delegate Function SayFxDelegate() As String

Public Class CGridSearch

  Public Function CalcOptim(ByVal nNumVars As Integer, ByRef fXCenter() As Double, ByRef fParam() As Double, _
                  ByRef fXLo() As Double, ByRef fXHi() As Double, ByRef nNumDiv() As Integer, _
                  ByRef fMinDeltaX() As Double, ByVal fEpsFx As Double, ByRef nIter As Integer, _
                  ByVal MyFx As MyFxDelegate) As Double
    Dim fDeltaX(), fX(), fBestX() As Double
    Dim F, fBestF, fLastBestF As Double
    Dim I As Integer
    Dim bGoOn As Boolean

    ReDim fDeltaX(nNumVars), fX(nNumVars), fBestX(nNumVars)

    For I = 0 To nNumVars - 1
      fXCenter(I) = (fXLo(I) + fXHi(I)) / 2
      fBestX(I) = fXCenter(I)
      fDeltaX(I) = (fXHi(I) - fXLo(I)) / nNumDiv(I)
      fX(I) = fXLo(I)
    Next

    ' calculate and display function value at initial point
    fBestF = MyFx(nNumVars, fXCenter, fParam)
    If fBestF > 0 Then
      fLastBestF = 100 + fBestF
    Else
      fLastBestF = 100 - fBestF
    End If

    nIter = 0
    Do

      Do
        nIter += 1

        F = MyFx(nNumVars, fX, fParam)
        If F < fBestF Then
          fLastBestF = fBestF
          fBestF = F
          For I = 0 To nNumVars - 1
            fBestX(I) = fX(I)
          Next I
        End If

        '*****************************************************
        ' The next For loop implements a programming tricks
        ' that simulated nested loops using just one For loop
        '*****************************************************
        ' search next grid node
        For I = 0 To nNumVars - 1
          If fX(I) >= fXHi(I) Then
            If I < (nNumVars - 1) Then
              fX(I) = fXLo(I)
            Else
              Exit Do
            End If
          Else
            fX(I) += fDeltaX(I)
            Exit For
          End If
        Next I
      Loop

      For I = 0 To nNumVars - 1
        fXCenter(I) = fBestX(I)
        fDeltaX(I) = fDeltaX(I) / nNumDiv(I)
        fXLo(I) = fXCenter(I) - fDeltaX(I) * nNumDiv(I) / 2
        fXHi(I) = fXCenter(I) + fDeltaX(I) * nNumDiv(I) / 2
        fX(I) = fXLo(I) ' set initial fX
      Next I

      ' fBestF = MyFx(XCenter, N)
      bGoOn = False
      For I = 0 To nNumVars - 1
        If fDeltaX(I) > fMinDeltaX(I) Then bGoOn = True
      Next I

      bGoOn = bGoOn And (Math.Abs(fBestF - fLastBestF) > fEpsFx)

    Loop While bGoOn

    Return fBestF

  End Function
End Class

